package net.mummila.crosswordgame;



// connection protocol.
public class CGProtocol {
	
	final public static String LETTERSLOTS_RECEIVED	= "CGP: LetterSlots received.";
	final public static String SCORE_RECEIVED		= "CGP: Score received.";
	final public static String CROSSWORD_RECEIVED	= "CGP: Crossword received.";
	final public static String ALPHABET_RECEIVED	= "CGP: Letters received.";
	final public static String MOVE_RECEIVED		= "CGP: Move received.";
	final public static String MOVE_FAILED			= "CGP: Move failed.";
	final public static String CLIENT_REQUESTING_CONTINUE	= "CGP: Client requesting continue.";
	final public static String SERVER_REQUESTING_CONTINUE	= "CGP: Server requesting continue.";
	final public static String CONTINUE_GRANTED				= "CGP: Continue granted.";
	final public static String SERVER_PROVIDES_CONTINUE		= "CGP: Server provides continue.";
	final public static String CLIENT_ACKNOWLEDGES_SPC		= "CGP: Client acknowledges SPC.";

	// each of these must be exactly one letter long.
	final public static String LETTERSLOT_EMPTY				= " ";
	final public static String LETTERSLOT_DISABLED			= "-";
	final public static String CROSSWORD_EMPTY_LETTER		= " ";
	final public static String CROSSWORD_FIXED_LETTER		= "F";
	final public static String CROSSWORD_UNFIXED_LETTER		= "U";

	final public static String MOVE_TYPES_INVALID	= "0";
	final public static String MOVE_TYPES_C2C		= "1";
	final public static String MOVE_TYPES_C2O		= "2";
	final public static String MOVE_TYPES_O2C		= "3";
	final public static String MOVE_TYPES_O2O		= "4";
	final public static String MOVE_TYPES_SWAP		= "5";
	final public static String MOVE_TYPES_CANCEL	= "6";
	final public static String MOVE_TYPES_FIX		= "7";
	final public static String MOVE_TYPES_UNDOFIX	= "8";
	final public static String MOVE_TYPES_GAME_OVER	= "9";
	final public static String MOVE_TYPES_PASS		= "P";

	
	
    // input signal testing.
    public static boolean isClientRequestingContinue(String signal) {
    	if (signal == null) return false;
    	return signal.equals(CLIENT_REQUESTING_CONTINUE);
    }
    public static boolean isContinueGranted(String signal) {
    	if (signal == null) return false;
    	return signal.equals(CONTINUE_GRANTED);
    }
    public static boolean isSPC(String signal) {
    	if (signal == null) return false;
    	return signal.equals(SERVER_PROVIDES_CONTINUE);
    }
    public static boolean isClientAcknowledgesSPC(String signal) {
    	if (signal == null) return false;
    	return signal.equals(CLIENT_ACKNOWLEDGES_SPC);
    }
    public static boolean isServerRequestingContinue(String signal) {
    	if (signal == null) return false;
    	return signal.equals(SERVER_REQUESTING_CONTINUE);
    }
    public static boolean isSlotsReceived(String signal) {
    	if (signal == null) return false;
    	return signal.equals(LETTERSLOTS_RECEIVED);
    }
    public static boolean isScoreReceived(String signal) {
    	if (signal == null) return false;
    	return signal.equals(SCORE_RECEIVED);
    }
    public static boolean isCrosswordReceived(String signal) {
    	if (signal == null) return false;
    	return signal.equals(CROSSWORD_RECEIVED);
    }
    public static boolean isAlphabetReceived(String signal) {
    	if (signal == null) return false;
    	return signal.equals(ALPHABET_RECEIVED);
    }
    public static boolean isMoveReceived(String signal) {
    	if (signal == null) return false;
    	return signal.equals(MOVE_RECEIVED);
    }
}
